#include<iostream>
#include<vector>
using namespace std;
int n,m;
const int MAXN = 1e5+5;
int ans[MAXN];
vector<int> a[MAXN];
bool used[MAXN];
void dfs(int x){
    used[x]=1;
    for(auto to:a[x]){
        if(!used[to]){
            dfs(to);
        }
        ans[x]+=ans[to];
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    m=n-1;
    int x,y;
    int f;
    for(int i=0;i<m;i++){
        cin>>x>>y;
        x--; y--;
        a[x].push_back(y);
        ans[x]++;
        if(i==0) f=x;
        else if(f==y) f=x;
    }
    dfs(f);
    int q;
    cin>>q;
    int c;
    for(int i=0;i<q;i++){
        cin>>c;
        c--;
        cout<<ans[c]<<"\n";
    }
    return 0;
}
